bl_info = {
    "name": "MeshMachine-剥离版",
    "author": "wxz",
    "version": (1, 0, 0),
    "blender": (4, 2, 0),
    "location": "View3D > Mesh > Edit Mode",
    "description": "关于倒角的实用增强工具",
    "warning": "",
    "wiki_url": "",
    "category": "Add Mesh",
}

import bpy

from .op_boolean_cleanup import PIE_BooleanCleanup
from .op_change_width import PIE_ChangeWidth
from .op_fuse import PIE_Fuse
from .op_offset_cut import PIE_OffsetCut
from .op_quad_corner import PIE_QuadCorner
from .op_refuse import PIE_Refuse
from .op_symmetrize import PIE_Symmetrize
from .op_turn_corner import PIE_TurnCorner
from .op_unbevel import PIE_Unbevel
from .op_unchamfer import PIE_Unchamfer
from .op_unfuck import PIE_Unfuck
from .op_unfuse import PIE_Unfuse

op_s = [ PIE_OffsetCut,
    PIE_Fuse,
    PIE_ChangeWidth,
    PIE_Unfuse,
    PIE_Refuse,
    PIE_Unchamfer,
    PIE_Unbevel,
    PIE_Unfuck,
    PIE_TurnCorner,
    PIE_QuadCorner,
    PIE_BooleanCleanup,
    PIE_Symmetrize,]


class MM_PT_SplitVersion(bpy.types.Panel):
    bl_idname = __qualname__
    bl_label = "MeshMachine-精简版"
    bl_category = "Tool"
    bl_space_type = "VIEW_3D"
    bl_region_type = "UI"

    def draw(self, context):
        layout = self.layout
        row = layout.row()
        row.operator(PIE_Fuse.bl_idname)
        row = layout.row()
        row.operator(PIE_ChangeWidth.bl_idname)
        row = layout.row()
        row.operator(PIE_TurnCorner.bl_idname)
        row = layout.row()
        row.operator(PIE_QuadCorner.bl_idname)
        row = layout.row()
        row.operator(PIE_Unchamfer.bl_idname)

        layout.separator(factor=0.1)
        row = layout.row()
        row.operator(PIE_Refuse.bl_idname)
        row = layout.row()
        row.operator(PIE_Unfuse.bl_idname)
        row = layout.row()
        row.operator(PIE_Unbevel.bl_idname)
        
        layout.separator(factor=0.1)
        row = layout.row()
        row.operator(PIE_Unfuck.bl_idname)
        row = layout.row()
        row.operator(PIE_OffsetCut.bl_idname)
        row = layout.row()
        row.operator(PIE_BooleanCleanup.bl_idname)
        
        layout.separator(factor=0.1)
        row = layout.row()
        row.operator(PIE_Symmetrize.bl_idname)
panel = MM_PT_SplitVersion
def update_panel(self, context):
    try:
        if "bl_rna" in MM_PT_SplitVersion.__dict__:
            bpy.utils.unregister_class(panel)

        prefs = context.preferences.addons[__package__].preferences
        if prefs.category != "":
            MM_PT_SplitVersion.bl_category = prefs.category
        else:
            MM_PT_SplitVersion.bl_category = "MeshMachine-精简版"
        bpy.utils.register_class(panel)

    except Exception as e:
        pass
class MM_SplitVersion_Pref(bpy.types.AddonPreferences):
    # this must match the addon name, use '__package__'
    # when defining this in a submodule of a python package.
    bl_idname = __package__

    category: bpy.props.StringProperty( # type: ignore
            name="侧边栏名称",
            description="选择面板类别的名称",
            default="MeshMachine-精简版",
            update=update_panel
            )
    modal_hud_color: bpy.props.FloatVectorProperty(name="显示字体颜色", subtype="COLOR", default=[1, 1, 1], size=3, min=0, max=1)  # type: ignore
    modal_hud_scale: bpy.props.FloatProperty(name="显示图形缩放", default=1, min=0.5, max=10)  # type: ignore
    modal_hud_hints: bpy.props.BoolProperty(name="显示提示", default=True)  # type: ignore
    symmetrize_flick_distance: bpy.props.IntProperty(name="轻拂确认距离", default=75, min=20, max=1000)  # type: ignore
    def draw(self, context):
        layout = self.layout

        row = layout.row()
        col = row.column()
        col.label(text="侧边栏名称:")
        col.prop(self, "category", text="")
        col.separator()
        row = col.row()
        row.prop(self, "modal_hud_color")
        row.prop(self, "modal_hud_scale")
        row = col.row()
        row.prop(self, "modal_hud_hints")
        row.prop(self, "symmetrize_flick_distance")


cls = [
    MM_SplitVersion_Pref,
    MM_PT_SplitVersion
]
classes = op_s + cls
class_register, class_unregister = bpy.utils.register_classes_factory(classes)


def register():
    class_register()


def unregister():
    class_unregister()

if __name__ == "__main__":
    register()
